// Fonctions fichiers  (enregt & lect fichiers sur SD card)
//- - - - - - - - - - - - - - - - - - - - - - - - - - - -

void initsdcard() {      // initialisation de la carte SD
   #if TRACES
     Serial.println("fonction : initsdcard");
   #endif  
   if (!SD.begin(sdpin)) {
     #if TRACES
       Serial.println("Echec initialisation carte SD"); // message port Série 
     #endif   
     sdabs = true;        // indic absence de carte SD
   }
   else sdabs = false;    // carte SD présente
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - -

void lecparam1() {                  // charger les paramètres depuis fich. PARAM1
  // enregt de la forme : "Mp";taille;paldis0;paldis1;paldis2;paldis3;palvar0;palvar1;palvar2   (valeurs en cm)
  #if TRACES
    Serial.println("fonction : lecparam1");
  #endif   
  fichier = SD.open("PARAM1.txt",FILE_READ);   
  if (!fichier) {                  //  échec ouverture
    #if TRACES
      Serial.println("Echec ouverture lecture pwd fichier PARAM1.txt"); 
    #endif
    sdko = true;                  // lecture fichier PARAM1.txt  KO
  } 
  else {
    cmd = "";  
    while (fichier.available())  {  
      char c = fichier.read();
      cmd += c;                  // stocker enregt dans string cmd
      #if TRACES
        Serial.print(c);        
      #endif           
    } 
    cmd += '\0';                 // mettre caractère fin de chaine
    fichier.close();
    sdko = false;                // lecture fichier PARAM1.txt OK
  }  
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - -

void enrparam1() {              // enregistrer les paramètres dans fich. PARAM1
  fichier = SD.open("PARAM1.txt",FILE_WRITE); // ouvre le fichier en écriture (ou crée fichier si absent)
  if (!fichier) {          //  échec ouverture
    #if TRACES
      Serial.println("Echec ouverture en sortie fichier PARAM1 : ");  
    #endif
    sdko = true;                // ouverture fichier PARAM1.txt  KO
  } 
  else { 
    cmd = "Init;"+String(taille)+";"+String(paldis[0])+";"+String(paldis[1])+";"+String(paldis[2])+";"+String(paldis[3]);
    cmd = cmd + ";"+String(palvar[0])+";"+String(palvar[1])+";"+String(palvar[2])+";"; 
    fichier.println(cmd); 
    fichier.close(); 
  }
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - -
void suppresparam1() {     // supprimer le fichier paramètres
  #if TRACES
    Serial.println("fonction : suppresparam1");
  #endif 
  if (SD.exists("PARAM1.txt"))  SD.remove("PARAM1.txt");  
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - -

void lecparam2() {   // charger les valeurs d'initialisation depuis fich. PARAM2
                     // enregt de la forme : "Init";dist_verti;min_haut;dist_bas;   (valeurs en cm)
  #if TRACES
    Serial.println("fonction : lecparam2");
  #endif   
  fichier = SD.open("PARAM2.txt",FILE_READ);   
  if (!fichier) {                  //  échec ouverture
    #if TRACES
      Serial.println("Echec ouverture lecture pwd fichier PARAM2.txt"); 
    #endif
    sdko = true;                  // lecture fichier PARAM2.txt  KO
  } 
  else {
    cmd = "";  
    while (fichier.available())  {  
      char c = fichier.read();
      cmd += c;                  // stocker enregt dans string cmd
      #if TRACES
        Serial.print(c);        
      #endif           
    } 
    cmd += '\0';                 // mettre caractère fin de chaine
    fichier.close();
    sdko = false;                // lecture fichier PARAM2.txt OK
  }  
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - -

void enrparam2() {              // enregistrer les valeurs d'initialisation dans fich. PARAM2
  fichier = SD.open("PARAM2.txt",FILE_WRITE); // ouvre le fichier en écriture (ou crée fichier si absent)
  if (!fichier) {               //  échec ouverture
    #if TRACES
      Serial.println("Echec ouverture en sortie fichier PARAM2 : ");  
    #endif
    sdko = true;                // ouverture fichier PARAM2.txt  KO
  } 
  else {         
    cmd = "Init;"+String(dist_verti)+";"+String(min_haut)+";"+String(dist_bas)+";";
    fichier.println(cmd); 
    fichier.close(); 
  }
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - -
void suppresparam2() {     // supprimer le fichier des valeurs d'initialisation
  #if TRACES
    Serial.println("fonction : suppresparam2");
  #endif 
  if (SD.exists("PARAM2.txt"))  SD.remove("PARAM2.txt");  
}
//************************fin SD_card********************************
